classification
Title: ensurepip should not be installed with --without-ensurepip
Type: Stage: resolved
Components: Installation Versions: Python 3.4
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: dstufft Nosy List: Arfrever, dstufft, ncoghlan
Priority: normal Keywords: patch

Created on 2014-01-28 11:54 by Arfrever, last changed 2014-09-08 09:50 by ncoghlan. This issue is now closed.

Files
File name Uploaded Description Edit
ensurepip_installation.patch Arfrever, 2014-01-28 11:54 review
Messages (5)
msg209536 - (view) Author: Arfrever Frehtes Taifersar Arahesis (Arfrever) * (Python triager) Date: 2014-01-28 11:54
ensurepip should not be installed when --without-ensurepip was passed to configure.
I attach the patch.
msg209537 - (view) Author: Donald Stufft (dstufft) * (Python committer) Date: 2014-01-28 12:25
I don't see any reason not to install ensurepip in this situation. That flag controls whether or not ``python -m ensurepip`` will be executed during the install, but ensurepip itself will still be installed. It is not an optional module
msg209695 - (view) Author: Arfrever Frehtes Taifersar Arahesis (Arfrever) * (Python triager) Date: 2014-01-30 00:02
Some distributions have policies about not bundling external code.
ensurepip currently bundles some versions of setuptools and pip.
msg209696 - (view) Author: Donald Stufft (dstufft) * (Python committer) Date: 2014-01-30 00:10
Yes I am aware of that. However ensurepip is also required to maintain functionality of the "venv" module in 3.4. See the guidelines in http://www.python.org/dev/peps/pep-0453/#recommendations-for-downstream-distributors which explicitly mentions the fact that this is functionality equivalent to the same bundling that occurs in virtualenv and I've yet to see a distribution not include that and not make an exception to the bundling policy.
msg226566 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2014-09-08 09:50
As Donald notes, this was explicitly covered in the PEP: the onus is on the distros to make ensurepip and pyvenv work in a way that complies with their debundling requirements (e.g. by using rewheel, or redirecting to the system installer).

The "--without-ensurepip" flag is there to disable running it at install time. Fully removing the ensurepip module is not a supported configuration - if a distro wants to do that, they're going to have to carry a patch.
History
Date User Action Args
2014-09-08 09:50:54ncoghlansetstatus: open -> closed
resolution: wont fix
messages: + msg226566

stage: patch review -> resolved
2014-09-08 08:33:26ned.deilysetnosy: + ncoghlan
2014-01-30 00:10:01dstufftsetmessages: + msg209696
2014-01-30 00:02:59Arfreversetmessages: + msg209695
2014-01-28 12:25:02dstufftsetmessages: + msg209537
2014-01-28 11:54:41Arfrevercreate